﻿Option Infer On
Option Explicit On
Option Strict On

Imports System
Imports System.Collections.Generic
Imports KadGen.SLTestApp.Common
Imports System.ComponentModel
Imports System.ComponentModel.Composition
Imports System.ComponentModel.DataAnnotations
Imports System.Runtime.Serialization

<BizClass(GetType(Invoice))> _
<Export(GetType(Invoice))> _
<PartCreationPolicy(CreationPolicy.NonShared)> _
<DataContract()> _
Public Class Invoice
   Implements IBizClass
   Implements ICoreBiz

   Private _instanceState As InstanceState
   <DataMember()> _
   Public Property InstanceState() As InstanceState Implements ICoreBiz.InstanceState
      Get
         Return _instanceState
      End Get
      Set(ByVal value As InstanceState)
         _instanceState = value
      End Set
   End Property

   Private _invoiceId As Int32
   <Required()> _
   <System.ComponentModel.DataAnnotations.Editable(False)> _
   <Display(Description:="The customer identifier", Prompt:="ID")> _
   <DataMember()> _
   Public Property InvoiceId() As Int32
      Get
         Return _invoiceId
      End Get
      Set(ByVal value As Int32)
         _invoiceId = value
      End Set
   End Property

   Private _invoiceNumber As String
   <DataMember()> _
   Public Property InvoiceNumber() As String

      Get
         Return _invoiceNumber
      End Get
      Set(ByVal value As String)
         _invoiceNumber = value
      End Set
   End Property

   Private _customerId As Int32
   <Required()> _
   <Editable(False)> _
   <Display(Description:="The customer identifier", Prompt:="ID")> _
  <DataMember()> _
   Public Property CustomerId() As Int32
      Get
         Return _customerId
      End Get
      Set(ByVal value As Int32)
         _customerId = value
      End Set
   End Property

   Private _invoiceDate As Date
   <Required()> _
   <Display(Description:="The invoice date", Prompt:="ID", AutoGenerateFilter:=True)> _
  <DataMember()> _
   Public Property InvoiceDate() As Date
      Get
         Return _invoiceDate
      End Get
      Set(ByVal value As Date)
         _invoiceDate = value
      End Set
   End Property

   Private _moreInfo As String
   <DataMember()> _
   Public Property MoreInfo() As String 
      Get
         Return _moreInfo
      End Get
      Set(ByVal value As String)
         _moreInfo = value
      End Set
   End Property

   Private _isPaid As Boolean
   <DataMember()> _
   Public Property IsPaid() As Boolean 
      Get
         Return _isPaid
      End Get
      Set(ByVal value As Boolean)
         _isPaid = value
      End Set
   End Property

   Private _lineItems As IList(Of InvoiceLineItem) = New List(Of InvoiceLineItem)
   <DataMember()> _
   Public Property LineItems() As IList(Of InvoiceLineItem)
      Get
         Return _lineItems
      End Get
      Set(ByVal value As IList(Of InvoiceLineItem))
         _lineItems = value
      End Set
   End Property

End Class