﻿Option Infer On
Option Explicit On
Option Strict On

Imports System
Imports KadGen.SLTestApp.Common
Imports System.ComponentModel.Composition
Imports System.ComponentModel.DataAnnotations
Imports System.Runtime.Serialization

<BizClass(GetType(InvoiceLineItem))> _
<Export(GetType(InvoiceLineItem))> _
<PartCreationPolicy(CreationPolicy.NonShared)> _
<DataContract()> _
Public Class InvoiceLineItem
   Implements IBizClass
   Implements ICoreBiz

   Private _instanceState As InstanceState
   <DataMember()> _
   Public Property InstanceState() As InstanceState Implements ICoreBiz.InstanceState
      Get
         Return _instanceState
      End Get
      Set(ByVal value As InstanceState)
         _instanceState = value
      End Set
   End Property

   Private _invoiceLineItemId As Int32
   <DataMember()> _
   Public Property InvoiceLineItemId() As Integer
      Get
         Return _invoiceLineItemId
      End Get
      Set(ByVal value As Integer)
         _invoiceLineItemId = value
      End Set
   End Property

   Private _productId As Int32
   <Display(Description:="The product identifier", Prompt:="ID")> _
   <DataMember()> _
   Public Property ProductId() As Int32
      Get
         Return _productId
      End Get
      Set(ByVal value As Int32)
         _productId = value
      End Set
   End Property

   Private _count As Int32
   <DataMember()> _
   Public Property Count() As Int32
      Get
         Return _count
      End Get
      Set(ByVal value As Int32)
         _count = value
      End Set
   End Property

   Private _cost As Double
   <DataMember()> _
   Public Property Cost() As Double
      Get
         Return _cost
      End Get
      Set(ByVal value As Double)
         _cost = value
      End Set
   End Property


End Class

