﻿Option Infer On
Option Explicit On
Option Strict On

Imports System
Imports System.ComponentModel.Composition
Imports System.Collections.Generic

Public Interface IBizService
   ReadOnly Property IsSearchProperty(ByVal propertyName As String) As Boolean
   ReadOnly Property CanReadProperty(ByVal propertyName As String) As Boolean
End Interface

Public Interface IBizServiceAsync(Of T)
   Inherits IBizService
   Sub BeginRetrieveList(ByVal filter As IFilter)
   Event RetrieveListCompletedEvent(ByVal sender As Object, ByVal e As RetrieveListCompetedEventArgs(Of T))
   Function CreateNew() As T
End Interface

Public Interface IBizServiceSync(Of T)
   Inherits IBizService
   Function RetrieveList(ByVal filter As IFilter) As IList(Of T)
   Function CreateNew() As T
End Interface

Public Interface IBizServiceComposition
   Inherits ITargetTypeProvider
End Interface

Public Class BizServiceAttribute
   Inherits TargetTypeProviderAttribute
   Implements IBizServiceComposition

   Public Sub New(ByVal targetType As Type)
      MyBase.New(GetType(IBizService), targetType)
   End Sub

End Class

