﻿Option Infer On
Option Explicit On
Option Strict On

Imports System
Imports System.ComponentModel.Composition

Public Interface ITargetTypeProvider
   ReadOnly Property TargetType() As Type
End Interface

Public Interface ITargetTypeProviderComposition
   Inherits ITargetTypeProvider
End Interface

<MetadataAttribute()> _
<AttributeUsage(AttributeTargets.Class, AllowMultiple:=False)> _
Public Class TargetTypeProviderAttribute
   Inherits ExportAttribute
   Implements ITargetTypeProviderComposition

   Private _targetType As Type

   Public Sub New(ByVal contractType As Type, ByVal targetType As Type)
      MyBase.New(contractType)
      _targetType = targetType
   End Sub

   Public ReadOnly Property TargetType() As System.Type Implements ITargetTypeProviderComposition.TargetType
      Get
         Return _targetType
      End Get
   End Property
End Class