﻿Option Infer On
Option Strict On
Option Explicit On

Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Runtime.Serialization
Imports System.ComponentModel

<DataContract()> _
Public Class ServiceContext
   Implements INotifyPropertyChanged

   Private _applicationName As String
   <DataMember()> Public Property ApplicationName() As [String]
      Get
         Return _applicationName
      End Get
      Set(ByVal value As [String])
         If value <> _applicationName Then
            _applicationName = value
            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("ApplicationName"))
         End If
      End Set
   End Property

   Private _errors As New List(Of ServiceError)()
   <DataMember()> _
   Public Property Errors() As List(Of ServiceError)
      Get
         Return Me._errors
      End Get
      Set(ByVal value As List(Of ServiceError))
         Me._errors = value
      End Set
   End Property

   Public Event PropertyChanged(ByVal sender As Object,
                                ByVal e As PropertyChangedEventArgs) _
                             Implements INotifyPropertyChanged.PropertyChanged
End Class
