﻿Option Infer On
Option Explicit On
Option Strict On

Imports System
Imports System.Linq
Imports System.Collections.Generic
Imports System.Windows
Imports System.Windows.Data

Public MustInherit Class VisibilityConverterBase
   Implements IValueConverter

   Protected MustOverride Function GetBool(ByVal value As Object) As Boolean

   Public Function Convert(ByVal value As Object, _
                           ByVal targetType As System.Type, _
                           ByVal reverseVisibility As Object, _
                           ByVal culture As System.Globalization.CultureInfo) _
                           As Object _
                           Implements System.Windows.Data.IValueConverter.Convert
      If targetType IsNot GetType(Visibility) OrElse value.GetType IsNot GetType(Boolean) Then
         Return Nothing
      End If
      Dim reverse = False
      If reverseVisibility IsNot Nothing Then
         reverse = CBool(reverseVisibility)
      End If
      Dim boolValue = GetBool(value)
      If boolValue Then
         Return If(reverse, Visibility.Collapsed, Visibility.Visible)
      Else
         Return If(reverse, Visibility.Visible, Visibility.Collapsed)
      End If
   End Function

   Public Function ConvertBack(ByVal value As Object, ByVal targetType As System.Type, ByVal parameter As Object, ByVal culture As System.Globalization.CultureInfo) As Object Implements System.Windows.Data.IValueConverter.ConvertBack
      Throw New NotImplementedException()
   End Function
End Class

Public Class BooleanToVisibilityConverter
   Inherits VisibilityConverterBase

   Protected Overrides Function GetBool(ByVal value As Object) As Boolean
      Return CBool(value)
   End Function
End Class
