﻿Option Infer On
Option Explicit On
Option Strict On

Imports System
Imports System.ComponentModel.Composition
Imports System.Collections

Public Interface IViewModel
   ReadOnly Property InstanceState() As InstanceState
   Sub Initialize()
   Sub Delete()
   Sub Update()
End Interface

Public Interface IViewModel(Of T)
   Inherits IViewModel
   Overloads Sub Initialize(ByVal model As T)
   Function Retrieve(ByVal id As Int32) As T
End Interface

Public Interface IViewModelComposition
   Inherits ITargetTypeProvider
End Interface

Public Class ViewModelAttribute
   Inherits TargetTypeProviderAttribute
   Implements IViewModelComposition

   Public Sub New(ByVal targetType As Type)
      MyBase.New(GetType(IViewModel), targetType)
   End Sub

End Class


