﻿Option Infer On
Option Explicit On
Option Strict On

Imports System
Imports System.Windows.Data
Imports System.ComponentModel
Imports System.ComponentModel.Composition
Imports System.Collections
Imports System.Collections.Generic

Public Interface IViewModelMany
   Inherits IList
   Sub RetrieveMany(ByVal filter As IFilter)
   Function CanReadProperty(ByVal propertyName As String) As Boolean
   Function IsSearchProperty(ByVal propertyName As String) As Boolean
   Function CreateNew() As IViewModel
End Interface

Public Interface IViewModelMany(Of T)
   Inherits IViewModelMany
End Interface

Public Interface IViewModelMany(Of T, TViewModel)
   Inherits IViewModelMany(Of T)
   Inherits IEnumerable(Of TViewModel)
   Shadows Function CreateNew(ByVal item As T) As TViewModel
End Interface


Public Interface IViewModelManyComposition
   Inherits ITargetTypeProvider
End Interface

Public Class ViewModelManyAttribute
   Inherits TargetTypeProviderAttribute
   Implements IViewModelManyComposition

   Public Sub New(ByVal targetType As Type)
      MyBase.New(GetType(IViewModelMany), targetType)
   End Sub

End Class