﻿Option Infer On
Option Explicit On
Option Strict On

Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports KadGen.SLTestApp.Common
Imports System.ComponentModel.Composition

<TargetTypePartRetriever()> _
Public Class TargetTypePartRetriever
   Inherits PartRetriever
   Implements ITargetTypePartRetriever

   Private _typeRetriever As ITypeRetriever

   <ImportingConstructor()>
   Public Sub New(<Import(AllowDefault:=True)> ByVal typeRetriever As ITypeRetriever)
      _typeRetriever = typeRetriever
   End Sub

   Public Overloads Function GetItem(Of T)(ByVal targetType As Type) As T Implements ITargetTypePartRetriever.GetItem
      Return MyBase.GetItem(Of T, ITargetTypeProviderComposition)(Function(x) x.TargetType Is targetType)
   End Function

   Public Overloads Function GetItem(Of T)(ByVal targetType As Type, ByVal useDefault As Boolean) As T Implements ITargetTypePartRetriever.GetItem
      Dim item = GetItem(Of T)(targetType)
      If item Is Nothing And useDefault Then
         item = GetItem(Of T)(CType(Nothing, Type))
      End If
      Return item
   End Function

   Public Overloads Function GetItem(Of T)(ByVal targetTypeName As String) As T Implements ITargetTypePartRetriever.GetItem
      Return GetItem(Of T)(targetTypeName, False)
   End Function

   Public Overloads Function GetItem(Of T)(ByVal targetTypeName As String, ByVal useDefault As Boolean) As T Implements ITargetTypePartRetriever.GetItem
      Dim targetType = _typeRetriever.GetTypeFromName(targetTypeName)
      Return GetItem(Of T)(targetType, useDefault)
   End Function

End Class
