﻿Option Infer On
Option Explicit On
Option Strict On

Imports System
Imports System.Linq
Imports System.Collections.Generic
Imports System.ComponentModel.Composition
Imports KadGen.SLTestApp.Common

<TypeRetriever()> _
Public Class TypeRetriever
   Implements ITypeRetriever

   <ImportMany()> _
   Public bizClassAssemblyMarkers As IEnumerable(Of Lazy(Of IBizContractAssemblyMarker))

   Public Function GetTypeFromName(ByVal name As String) _
               As System.Type _
               Implements ITypeRetriever.GetTypeFromName
      If bizClassAssemblyMarkers.Count = 0 Then
         Throw New InvalidOperationException("There must be at least one assembly containing a class that exports IBizClassAssembly")
      End If
      For Each marker In bizClassAssemblyMarkers
         ' It's not a big deal that we load the assemblies here, because most of them will be used immediately
         Dim assembly = marker.Value.GetType.Assembly
         Dim q = assembly.GetTypes.Where(Function(t) t.Name = name)
         If q.count > 0 Then
            Return q.First
         End If
      Next
      Throw New InvalidOperationException("Type not found")
   End Function

End Class
