﻿Option Infer On
Option Explicit On
Option Strict On

Imports System
Imports System.Windows.Data
Imports System.ComponentModel
Imports System.Collections.ObjectModel
Imports System.ComponentModel.Composition
Imports KadGen.SLTestApp.Common

Public Class ViewModelManyBase(Of T, TViewModel As IViewModel(Of T))
   Inherits ObservableCollection(Of TViewModel)
   Implements IViewModelMany(Of T, TViewModel)

   Private _isInitialized As Boolean

   <Import()>
   Public WithEvents _internalService As IBizServiceAsync(Of T)

   <Import(AllowDefault:=True)> _
   Public Property _service() As IBizServiceAsync(Of T)
      Get
         Return _internalService
      End Get
      Set(ByVal value As IBizServiceAsync(Of T))
         _internalService = value
      End Set
   End Property

   <Import(AllowDefault:=True)> _
   Public _vmCreator As ExportFactory(Of TViewModel)

   Public Function CanReadProperty(ByVal propertyName As String) As Boolean Implements IViewModelMany.CanReadProperty
      Return _service.CanReadProperty(propertyName)
   End Function

   Public Function CreateNew() As IViewModel Implements IViewModelMany.CreateNew
      Dim vm = _vmCreator.CreateExport().Value
      vm.Initialize()
      Return vm
   End Function

   Public Function CreateNew(ByVal item As T) As TViewModel Implements IViewModelMany(Of T, TViewModel).CreateNew
      Dim vm = _vmCreator.CreateExport().Value
      vm.Initialize(item)
      Return vm
   End Function

   Public Function IsSearchProperty(ByVal propertyName As String) As Boolean Implements IViewModelMany.IsSearchProperty
      Return _service.IsSearchProperty(propertyName)
   End Function

   Public Sub RetrieveMany(ByVal filter As IFilter) Implements IViewModelMany.RetrieveMany
      'If Not _isInitialized Then
      '   AddHandler _service.RetrieveListCompletedEvent, AddressOf service_RetrieveListCompletedEvent
      'End If
      _service.BeginRetrieveList(filter)
   End Sub

   Private Sub AddInternal(ByVal item As T)
      Dim vm = _vmCreator.CreateExport().Value
      vm.Initialize(item)
      Me.Add(vm)
   End Sub

   Private Sub service_RetrieveListCompletedEvent( _
            ByVal sender As Object, _
            ByVal e As RetrieveListCompetedEventArgs(Of T)) _
            Handles _internalService.RetrieveListCompletedEvent
      For Each x In e.Result
         AddInternal(x)
      Next
   End Sub

End Class
