﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel.Composition;
using System.Reflection;

namespace CodeRapid.PagedCollectionViewMef
{
   public class MefSupport
   {
      static internal bool CanCreate(Type type)
      {
         var methodInfo = typeof(MefSupport).GetMethod("CanCreateInternal", BindingFlags.Static | BindingFlags.NonPublic );
         var genericMethod = methodInfo.MakeGenericMethod(new Type[] { type });
         return (bool)genericMethod.Invoke(null, null);
      }

      static internal object Create(Type type)
      {
         var methodInfo = typeof(MefSupport).GetMethod("CreateInternal", BindingFlags.Static | BindingFlags.NonPublic);
         var genericMethod = methodInfo.MakeGenericMethod(new Type[] { type });
         return genericMethod.Invoke(null, null);
      }

      static private bool CanCreateInternal<T>()
      {
         var x = new MefSupportInternal<T>();
         return x.CanCreate();
      }

      static private object CreateInternal<T>()
      {
         var x = new MefSupportInternal<T>();
         return x.Create();
      }

      public class MefSupportInternal<T>
      {
         [Import(AllowDefault=true)]
         public ExportFactory<T> _creator;

         public MefSupportInternal()
         {
            CompositionInitializer.SatisfyImports(this);
         }

         public bool CanCreate()
         { return _creator != null; }

         public object Create()
         { return _creator.CreateExport().Value; }
      }
   }
}
