﻿Option Infer On
Option Explicit On
Option Strict On

Imports System
Imports System.Linq
Imports System.Collections.Generic
Imports KadGen.SLTestApp.Common
Imports KadGen.SLTestApp.BusinessClasses

<WcfWrapper(GetType(Customer))> _
Public Class CustomerWcfWrapper
   Implements IWcfWrapper(Of Customer)

   Public Event RetrieveListCompletedEvent(ByVal sender As Object, _
            ByVal e As RetrieveListCompetedEventArgs(Of Customer)) _
            Implements IWcfWrapper(Of Customer).RetrieveListCompletedEvent

   Public Sub BeginRetrieveList(ByVal filter As IFilter, Optional ByVal userState As Object = Nothing) _
            Implements IWcfWrapper(Of Customer).BeginRetrieveList
      Dim svc = New CustomerService.CustomerServiceClient()
      Dim serviceContext = New ServiceContext

      AddHandler svc.RetrieveListCompleted, AddressOf RetrieveListCompleted
      svc.RetrieveListAsync(serviceContext, CType(filter, Filter))
   End Sub

   Private Sub RetrieveListCompleted(ByVal sender As Object, ByVal e As CustomerService.RetrieveListCompletedEventArgs)
      Dim q As IEnumerable(Of Customer) = Nothing
      If e.Result IsNot Nothing Then
         q = (From x In e.Result Select TryCast(x, Customer)).ToList()
      End If
      RaiseEvent RetrieveListCompletedEvent(Nothing, New RetrieveListCompetedEventArgs(Of Customer)( _
                                             q, e.serviceContext, e.Error, e.Cancelled, e.UserState))
   End Sub

End Class
