﻿Option Infer On
Option Explicit On
Option Strict On

Imports System
Imports System.Linq
Imports System.Collections.Generic
Imports KadGen.SLTestApp.Common
Imports KadGen.SLTestApp.BusinessClasses

<WcfWrapper(GetType(Invoice))> _
Public Class InvoiceWcfWrapper
   Implements IWcfWrapper(Of Invoice)

   Public Sub BeginRetrieveList(ByVal filter As IFilter, Optional ByVal userState As Object = Nothing) _
            Implements IWcfWrapper(Of Invoice).BeginRetrieveList
      Dim svc = New InvoiceService.InvoiceServiceClient()
      Dim serviceContext = New ServiceContext()
      AddHandler svc.RetrieveListCompleted, AddressOf RetrieveListCompleted
      svc.RetrieveListAsync(serviceContext, CType(filter, Filter))
   End Sub

   Private Sub RetrieveListCompleted(ByVal sender As Object, ByVal e As InvoiceService.RetrieveListCompletedEventArgs)
      Dim q As IEnumerable(Of Invoice) = Nothing
      If e.Result IsNot Nothing Then
         q = (From x In e.Result Select TryCast(x, Invoice)).ToList()
      End If
      RaiseEvent RetrieveListCompletedEvent(Nothing, New RetrieveListCompetedEventArgs(Of Invoice)(
                                             q, e.serviceContext, e.Error, e.Cancelled, e.UserState))
   End Sub

   Public Event RetrieveListCompletedEvent(ByVal sender As Object, _
                                      ByVal e As RetrieveListCompetedEventArgs(Of Invoice)) _
                                      Implements IWcfWrapper(Of Invoice).RetrieveListCompletedEvent
End Class
