﻿Option Infer On
Option Explicit On
Option Strict On

Imports System
Imports System.Linq
Imports System.Collections.Generic
Imports KadGen.SLTestApp.Common
Imports KadGen.SLTestApp.BusinessClasses

<WcfWrapper(GetType(Product))> _
Public Class ProductWcfWrapper
   Implements IWcfWrapper(Of Product)

   Public Event RetrieveListCompletedEvent(ByVal sender As Object, _
                                      ByVal e As RetrieveListCompetedEventArgs(Of Product)) _
                                      Implements IWcfWrapper(Of Product).RetrieveListCompletedEvent

   Public Sub BeginRetrieveList(ByVal filter As IFilter, Optional ByVal userState As Object = Nothing) _
            Implements IWcfWrapper(Of Product).BeginRetrieveList
      Dim svc = New ProductService.ProductServiceClient()
      Dim serviceContext = New ServiceContext()
      AddHandler svc.RetrieveListCompleted, AddressOf RetrieveListCompleted
      svc.RetrieveListAsync(serviceContext, CType(filter, Filter))
   End Sub

   Private Sub RetrieveListCompleted(ByVal sender As Object, ByVal e As ProductService.RetrieveListCompletedEventArgs)
      Dim q As IEnumerable(Of Product) = Nothing
      If e.Result IsNot Nothing Then
         q = (From x In e.Result Select TryCast(x, Product)).ToList()
      End If
      RaiseEvent RetrieveListCompletedEvent(Nothing, New RetrieveListCompetedEventArgs(Of Product)(
                                            q, e.serviceContext, e.Error, e.Cancelled, e.UserState))
   End Sub

End Class
