﻿Option Infer On
Option Strict On
Option Explicit On

Imports System
Imports System.Collections.Generic
Imports System.ServiceModel
Imports System.ServiceModel.Activation
Imports KadGen.SLTestApp.BusinessClasses
Imports KadGen.SLTestApp.Common

<AspNetCompatibilityRequirements(RequirementsMode:=AspNetCompatibilityRequirementsMode.Allowed)> _
Public Class CustomerService
   Implements ICustomerService

   Public Function RetrieveList(ByRef serviceContext As ServiceContext,
                                ByVal filter As Filter) _
            As List(Of Customer) _
            Implements ICustomerService.RetrieveList
      Dim ret = New List(Of Customer)
      Try
         Dim customer = New Customer With {.CustomerId = 40, .CustomerName = "Sam Spade"}
         ret.Add(customer)
         customer = New Customer With {.CustomerId = 41, .CustomerName = "Card Shark"}
         ret.Add(customer)
         ' etc.
         Return ret
      Catch ex As System.Exception
         serviceContext.Errors.Add(New ServiceError() With {.ErrorMessage = "Service Failure",
                                                            .ErrorSeverity = ErrorSeverity.Severe,
                                                            .MoreInformation = ex.ToString()})
         Return ret
      End Try
   End Function

   Public Function HelloWorld() As String Implements ICustomerService.HelloWorld
      Return "Hello World"
   End Function
End Class

