﻿Option Infer On
Option Strict On
Option Explicit On

Imports System
Imports System.Collections.Generic
Imports System.ServiceModel
Imports System.ServiceModel.Activation
Imports KadGen.SLTestApp.Common
Imports KadGen.SLTestApp.BusinessClasses

<AspNetCompatibilityRequirements(RequirementsMode:=AspNetCompatibilityRequirementsMode.Allowed)> _
Public Class InvoiceService
   Implements IInvoiceService

   Public Function RetrieveList(ByRef serviceContext As ServiceContext, ByVal filter As Filter) _
            As List(Of Invoice) _
            Implements IInvoiceService.RetrieveList
      Dim ret = New List(Of Invoice)
      Try
         'Throw New NotImplementedException()
         Dim invoice = New Invoice With {.InvoiceId = 100, .CustomerId = 40, .InvoiceDate = CDate("2/3/2010")}
         invoice.LineItems.Add(New InvoiceLineItem With {.ProductId = 11, .Count = 2, .Cost = 0.75})
         invoice.LineItems.Add(New InvoiceLineItem With {.ProductId = 12, .Count = 1, .Cost = 2.5})
         invoice.LineItems.Add(New InvoiceLineItem With {.ProductId = 13, .Count = 2, .Cost = 12.39})
         ret.Add(invoice)
         invoice = New Invoice With {.InvoiceId = 101, .CustomerId = 41, .InvoiceDate = CDate("2/3/2010")}
         invoice.LineItems.Add(New InvoiceLineItem With {.ProductId = 11, .Count = 2, .Cost = 35.62})
         invoice.LineItems.Add(New InvoiceLineItem With {.ProductId = 12, .Count = 1, .Cost = 10.11})
         invoice.LineItems.Add(New InvoiceLineItem With {.ProductId = 13, .Count = 2, .Cost = 22.17})
         ret.Add(invoice)
         invoice = New Invoice With {.InvoiceId = 102, .CustomerId = 41, .InvoiceDate = CDate("2/3/2010")}
         invoice.LineItems.Add(New InvoiceLineItem With {.ProductId = 11, .Count = 2, .Cost = 12.75})
         invoice.LineItems.Add(New InvoiceLineItem With {.ProductId = 12, .Count = 1, .Cost = 1234.56})
         ret.Add(invoice)
         Return ret
      Catch ex As System.Exception
         serviceContext.Errors.Add(New ServiceError() With {.ErrorMessage = "Service Failure",
                                                            .ErrorSeverity = ErrorSeverity.Severe,
                                                            .MoreInformation = ex.ToString()})
         Return ret
      End Try
   End Function
End Class
