﻿Option Infer On
Option Strict On
Option Explicit On

Imports System
Imports System.Collections.Generic
Imports System.ServiceModel
Imports System.ServiceModel.Activation
Imports KadGen.SLTestApp.Common
Imports KadGen.SLTestApp.BusinessClasses

<AspNetCompatibilityRequirements(RequirementsMode:=AspNetCompatibilityRequirementsMode.Allowed)> _
Public Class ProductService
   Implements IProductService

   Public Function RetrieveList(ByRef serviceContext As ServiceContext,
                                ByVal filter As Filter) _
            As List(Of Product) _
            Implements IProductService.RetrieveList
      Dim ret = New List(Of Product)
      Try
         ' Add items
         Dim product = New Product With {.ProductId = 11, .ProductName = "Rock"}
         ret.Add(product)
         product = New Product With {.ProductId = 12, .ProductName = "Paper"}
         ret.Add(product)
         product = New Product With {.ProductId = 13, .ProductName = "Scissors"}
         ret.Add(product)
         product = New Product With {.ProductId = 14, .ProductName = "Heart"}
         ret.Add(product)
         product = New Product With {.ProductId = 15, .ProductName = "Spade"}
         ret.Add(product)
         product = New Product With {.ProductId = 16, .ProductName = "Club"}
         ret.Add(product)
         product = New Product With {.ProductId = 17, .ProductName = "Diamond"}
         ret.Add(product)
         product = New Product With {.ProductId = 18, .ProductName = "Knife"}
         ret.Add(product)
         product = New Product With {.ProductId = 19, .ProductName = "LivingRoom"}
         ret.Add(product)
         Return ret
      Catch ex As System.Exception
         serviceContext.Errors.Add(New ServiceError() With {.ErrorMessage = "Service Failure",
                                                            .ErrorSeverity = ErrorSeverity.Severe,
                                                            .MoreInformation = ex.ToString()})
         Return ret
      End Try
   End Function
End Class
