﻿Option Infer On
Option Explicit On
Option Strict On

Imports System
Imports System.ComponentModel.Composition
Imports KadGen.SLTestApp.Common
Imports System.Windows
Imports System.Windows.Controls
Imports System.Collections.Generic
Imports KadGen.SLTestApp.TestApplication

Partial Public Class App
   Inherits Application

   Public Sub New()
      InitializeComponent()
   End Sub

   <Import(GetType(MainPage))> _
   Public _mainPage As MainPage

   <Import()> _
   Public _targetTypeRetriever As ITargetTypePartRetriever

   Private Sub Application_Startup(ByVal o As Object, ByVal e As StartupEventArgs) Handles Me.Startup
      CompositionInitializer.SatisfyImports(Me)
      If _mainPage Is Nothing Then
         Me.RootVisual = New MainPage
         'Throw New InvalidOperationException("Main page not discovered")
      Else
         Me.RootVisual = _mainPage
      End If
   End Sub

   Private Sub Application_UnhandledException(ByVal sender As Object, ByVal e As ApplicationUnhandledExceptionEventArgs) Handles Me.UnhandledException

      ' If the app is running outside of the debugger then report the exception using
      ' the browser's exception mechanism. On IE this will display it a yellow alert 
      ' icon in the status bar and Firefox will display a script error.
      If Not System.Diagnostics.Debugger.IsAttached Then

         ' NOTE: This will allow the application to continue running after an exception has been thrown
         ' but not handled. 
         ' For production applications this error handling should be replaced with something that will 
         ' report the error to the website and stop the application.
         e.Handled = True
         Dim errorWindow As ChildWindow = New ErrorWindow(e.ExceptionObject)
         errorWindow.Show()
      End If
   End Sub

End Class
