﻿Option Infer On
Option Explicit On
Option Strict On

Imports System
Imports System.ComponentModel.Composition
Imports KadGen.SLTestApp.Common
Imports System.Windows.Data
Imports System.ComponentModel
Imports System.Windows
Imports System.Windows.Controls

<EditView(Nothing)> _
<PartCreationPolicy(CreationPolicy.NonShared)> _
Partial Public Class EditView
   Inherits UserControl
   Implements IEditView

   <Import()> _
   Public _retriever As ITargetTypePartRetriever
   <Import()> _
   Public _childGridCreator As ExportFactory(Of IChildDataGrid)
   Private _viewModelMany As IViewModelMany
   Private _targetType As Type

   Public Sub New()
      InitializeComponent()
   End Sub

   Public Sub Initialize(ByVal targetType As Type, ByVal filter As IFilter) Implements IEditView.Initialize
      _targetType = targetType
      AddHandler DataForm.DeletingItem, AddressOf Me.DataForm_DeletingItem
      AddHandler DataForm.AutoGeneratingField, AddressOf DataForm_AutoGeneratingField
      _viewModelMany = _retriever.GetItem(Of IViewModelMany)(targetType, False)
      _viewModelMany.RetrieveMany(filter)
      Me.DataContext = _viewModelMany
      Me.DataForm.DataContext = New CodeRapid.PagedCollectionViewMef.PagedCollectionViewMef(_viewModelMany)
      ' Me.DataContext = _viewModelMany
   End Sub

   Private Sub DataForm_AutoGeneratingField(ByVal sender As System.Object, ByVal e As DataFormAutoGeneratingFieldEventArgs)
      If Not _viewModelMany.CanReadProperty(e.PropertyName) Then
         e.Cancel = True
         Return
      End If
      If e.PropertyType.IsEnumerableNotString Then
         Dim childGrid = _childGridCreator.CreateExport.Value()
         Dim gridAsUC = CType(childGrid, UserControl)
         childGrid.Initialize(e.PropertyName, e.PropertyType, _targetType)
         e.Field.Content = gridAsUC
      End If
   End Sub

   Private Sub DataForm_DeletingItem(ByVal sender As Object, ByVal e As CancelEventArgs)
      Dim current = CType(DataForm.CurrentItem, IViewModel)
      current.Delete()
   End Sub
End Class
