﻿Option Infer On
Option Explicit On
Option Strict On

Imports System
Imports System.ComponentModel.Composition
Imports KadGen.SLTestApp.Common
Imports System.Collections
Imports System.Windows
Imports System.Windows.Controls

Partial Public Class GeneralForm
   Inherits Page

   <Import()> _
   Public _retriever As ITargetTypePartRetriever
   <Import()> _
   Public _typeRetriever As ITypeRetriever

   Public Sub New()
      InitializeComponent()
      CompositionInitializer.SatisfyImports(Me)
   End Sub

   Private _searchChild As ChildWindow
   Private _searchForm As ISearchForm
   Private _bizClassName As String
   Private _bizType As Type
   Private _bizService As IBizService

   Protected Overrides Sub OnNavigatedTo(ByVal e As System.Windows.Navigation.NavigationEventArgs)
      Dim argName = "biz"
      If NavigationContext.QueryString.ContainsKey(argName) Then
         _bizClassName = NavigationContext.QueryString(argName)
         _bizType = _typeRetriever.GetTypeFromName(_bizClassName)
         _searchForm = _retriever.GetItem(Of ISearchForm)(_bizType, True)
         _searchChild = TryCast(_searchForm, ChildWindow)
         If _searchChild Is Nothing Then
            Throw New InvalidOperationException("Must be child window")
         End If
         AddHandler _searchChild.Closed, AddressOf Search_Closed
         _searchForm.Show(_bizClassName)
      End If
   End Sub

   Private Sub Search_Closed(ByVal sender As Object, ByVal e As EventArgs)
      If _searchChild.DialogResult Then
         Dim edit = _retriever.GetItem(Of IEditView)(_bizType, True)
         Dim editUC = TryCast(edit, UserControl)
         If editUC Is Nothing Then
            Throw New InvalidOperationException("Edit View must be a user control")
         End If
         edit.Initialize(_bizType, _searchForm.Filter)
         Me.dataContentBorder.Child = editUC
      Else
         Me.NavigationService.GoBack()
      End If
   End Sub
End Class
