﻿Option Infer On
Option Explicit On
Option Strict On

Imports System
Imports KadGen.SLTestApp.Common
Imports System.ComponentModel.Composition
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Data

<SearchForm(Nothing)> _
Partial Public Class SearchForm
   Inherits ChildWindow
   Implements ISearchForm

   <Import()> _
   Public _retriever As ITargetTypePartRetriever
   Private _viewModelMany As IViewModelMany

   Public Sub New()
      InitializeComponent()
   End Sub

   Public Overloads Sub Show(ByVal targetTypeName As String) Implements ISearchForm.Show
      _viewModelMany = _retriever.GetItem(Of IViewModelMany)(targetTypeName)
      Dim searchItem = _viewModelMany.CreateNew()
      Me.DataContext = New Object() {searchItem}
      searchDataForm.CommandButtonsVisibility = DataFormCommandButtonsVisibility.None
      Me.Title = targetTypeName & " Search"
      Me.Show()
   End Sub

   Private Sub OKButton_Click(ByVal sender As Object, ByVal e As RoutedEventArgs) Handles OKButton.Click
      Me.DialogResult = True
   End Sub

   Private Sub CancelButton_Click(ByVal sender As Object, ByVal e As RoutedEventArgs) Handles CancelButton.Click
      Me.DialogResult = False
   End Sub

   Private Sub DataForm_AutoGeneratingField(ByVal sender As System.Object, ByVal e As System.Windows.Controls.DataFormAutoGeneratingFieldEventArgs)
      e.Cancel = Not (_viewModelMany.CanReadProperty(e.PropertyName) AndAlso _viewModelMany.IsSearchProperty(e.PropertyName))
   End Sub

   Public ReadOnly Property Filter() As IFilter Implements ISearchForm.Filter
      Get
         ' Actual filtering is not yet implemented
         Return Nothing
      End Get
   End Property
End Class
