﻿Option Infer On
Option Explicit On
Option Strict On

Imports System
Imports System.Linq
Imports System.ComponentModel
Imports System.ComponentModel.Composition
Imports KadGen.SLTestApp.Common
Imports System.Collections
Imports System.ComponentModel.DataAnnotations
Imports KadGen.SLTestApp.BusinessClasses

<ViewModelLookup(GetType(Product))> _
<Export(GetType(IViewModelLookup(Of Product)))> _
Public Class ProductViewModelLookup
   Inherits ViewModelManyBase(Of Product, ProductViewModel)
   Implements IViewModelLookup(Of Product)

   <Import()> _
   Public _list As ProductViewModelMany
   Private _isFilled As Boolean

   Public Function LookupDisplay(ByVal id As Int32) _
               As String _
               Implements IViewModelLookup.Lookup
      If Not _isFilled Then
         _list.RetrieveMany(Nothing)
         _isFilled = True
      End If
      Dim product = (From c In _list Where c.ProductId = id).FirstOrDefault
      If product IsNot Nothing Then
         Return product.ProductName
      End If
      Return "Product ID not found: " & CStr(id)
   End Function
End Class

<ViewModelMany(GetType(Product))> _
<Export(GetType(ProductViewModelMany))> _
<PartCreationPolicy(CreationPolicy.NonShared)> _
Public Class ProductViewModelMany
   Inherits ViewModelManyBase(Of Product, ProductViewModel)
End Class


<ViewModel(GetType(Product))> _
<Export(GetType(ProductViewModel))> _
<PartCreationPolicy(CreationPolicy.NonShared)> _
Public Class ProductViewModel
   Inherits ViewModelBase(Of Product)

   Public Property ProductId() As Int32
      Get
         Return Model.ProductId
      End Get
      Set(ByVal value As Int32)
         Model.ProductId = value
      End Set
   End Property

   Public Property ProductName() As String
      Get
         Return Model.ProductName
      End Get
      Set(ByVal value As String)
         Model.ProductName = value
      End Set
   End Property

End Class
