﻿Option Infer On
Option Explicit On
Option Strict On

Imports System
Imports System.ComponentModel
Imports System.ComponentModel.Composition
Imports KadGen.SLTestApp.Common
Imports System.Collections
Imports System.ComponentModel.DataAnnotations

''' <summary>
''' 
''' </summary>
''' <typeparam name="T">Core contract such as Product</typeparam>
''' <typeparam name="TModelContract">Contract used, such as IProductStandard</typeparam>
''' <remarks></remarks>
Public MustInherit Class ViewModelBase(Of T As ICoreBiz, TModelContract As T)
   Implements IViewModel(Of T)
   Implements ICoreBiz

   Private _model As TModelContract
   Private _service As IBizServiceAsync(Of T)

   <Import()> _
   Public _retriever As ITargetTypePartRetriever

   Public Sub Initialize(ByVal model As T) Implements IViewModel(Of T).Initialize
      _model = CType(model, TModelContract)
   End Sub

   Friend Sub Initialize() Implements IViewModel(Of T).Initialize
      _model = CType(Service.CreateNew(), TModelContract)
   End Sub

   Protected ReadOnly Property Model() As TModelContract
      Get
         Return _model
      End Get
   End Property

   Protected ReadOnly Property Service() As IBizServiceAsync(Of T)
      Get
         If _service Is Nothing Then
            _service = CType(_retriever.GetItem(Of IBizService)(GetType(T)), IBizServiceAsync(Of T))
         End If
         Return _service
      End Get
   End Property

   Public Sub Delete() Implements IViewModel.Delete
      _model.InstanceState = InstanceState.Deleted
   End Sub

   Public ReadOnly Property InstanceState() As InstanceState Implements IViewModel.InstanceState
      Get
         Return _model.InstanceState
      End Get
   End Property

   Public Property InstanceState1() As InstanceState Implements ICoreBiz.InstanceState
      Get
         Return _model.InstanceState
      End Get
      Set(ByVal value As InstanceState)
         _model.InstanceState = value
      End Set
   End Property

   Public Sub Update() Implements IViewModel.Update
      'Service.Update()
   End Sub


   Public Function Retrieve(ByVal id As Integer) As T Implements IViewModel(Of T).Retrieve
      ' Service.Retrieve
   End Function


End Class
